////////////////////////////////////////////////////////////////////////
//
// This file is part of Common Text Transformation Library.
// Copyright (C) 1997-2009 by Igor Kholodov. 
//
// Common Text Transformation Library is free software: you can
// redistribute it and/or modify it under the terms of the
// GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Common Text Transformation Library is distributed in the hope
// that it will be useful, but WITHOUT ANY WARRANTY; without even
// the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with Common Text Transformation Library.
// If not, see <http://www.gnu.org/licenses/>.
//
// mailto:cttl@users.sourceforge.net
// http://cttl.sourceforge.net/
// http://sourceforge.net/projects/cttl/
//
////////////////////////////////////////////////////////////////////////

// java_alphabet.cpp
#include <string>

namespace {
    // Java Abstract Alphabet
    const std::string LITERAL_EQ     = "=";
    const std::string LITERAL_ADD_EQ = "+=";
    const std::string LITERAL_SUB_EQ = "-=";
    const std::string LITERAL_AST_EQ = "*=";
    const std::string LITERAL_DIV_EQ = "/=";
    const std::string LITERAL_AMP_EQ = "&=";
    const std::string LITERAL_OR_EQ  = "|=";
    const std::string LITERAL_XOR_EQ = "^=";
    const std::string LITERAL_PCT_EQ = "%=";
    const std::string LITERAL_2LT_EQ = "<<=";
    const std::string LITERAL_2GT_EQ = ">>=";
    const std::string LITERAL_3GT_EQ = ">>>=";

    const std::string LITERAL_2OR    = "||" ;
    const std::string LITERAL_2AMP   = "&&" ;
    const std::string LITERAL_2EQ    = "==" ;
    const std::string LITERAL_BANG_EQ= "!=" ;
    const std::string LITERAL_OR     = "|"  ;
    const std::string LITERAL_LT_EQ  = "<=" ;
    const std::string LITERAL_GT_EQ  = ">=" ;
    const std::string LITERAL_2LT    = "<<" ;
    const std::string LITERAL_2GT    = ">>" ;
    const std::string LITERAL_3GT    = ">>>" ;
    const std::string LITERAL_XOR    = "^" ;
    const std::string LITERAL_AMP    = "&" ;
    const std::string LITERAL_LT     = "<" ;
    const std::string LITERAL_GT     = ">" ;
    const std::string LITERAL_ADD    = "+" ;
    const std::string LITERAL_SUB    = "-" ;
    const std::string LITERAL_AST    = "*" ;
    const std::string LITERAL_DIV    = "/" ;
    const std::string LITERAL_PCT    = "%" ;

    const std::string LITERAL_INC    = "++" ;
    const std::string LITERAL_DEC    = "--" ;
    const std::string LITERAL_BANG   = "!" ;
    const std::string LITERAL_TILDE  = "~" ;

    const std::string LITERAL_STRICTFP     = "strictfp" ;
    const std::string LITERAL_ABSTRACT     = "abstract" ;
    const std::string LITERAL_DOUBLE       = "double" ;
    const std::string LITERAL_INT          = "int" ;
    const std::string LITERAL_BOOLEAN      = "boolean" ;
    const std::string LITERAL_ELSE         = "else" ;
    const std::string LITERAL_INTERFACE    = "interface" ;
    const std::string LITERAL_SUPER        = "super" ;
    const std::string LITERAL_BREAK        = "break" ;
    const std::string LITERAL_EXTENDS      = "extends" ;
    const std::string LITERAL_LONG         = "long" ;
    const std::string LITERAL_SWITCH       = "switch" ;
    const std::string LITERAL_BYTE         = "byte" ;
    const std::string LITERAL_FINAL        = "final" ;
    const std::string LITERAL_NATIVE       = "native" ;
    const std::string LITERAL_SYNCHRONIZED = "synchronized" ;
    const std::string LITERAL_CASE         = "case" ;
    const std::string LITERAL_FINALLY      = "finally" ;
    const std::string LITERAL_NEW          = "new" ;
    const std::string LITERAL_THIS         = "this" ;
    const std::string LITERAL_CATCH        = "catch" ;
    const std::string LITERAL_FLOAT        = "float" ;
    const std::string LITERAL_PACKAGE      = "package" ;
    const std::string LITERAL_THROW        = "throw" ;
    const std::string LITERAL_CHAR         = "char" ;
    const std::string LITERAL_FOR          = "for" ;
    const std::string LITERAL_PRIVATE      = "private" ;
    const std::string LITERAL_THROWS       = "throws" ;
    const std::string LITERAL_CLASS        = "class" ;
    const std::string LITERAL_PROTECTED    = "protected" ;
    const std::string LITERAL_TRANSIENT    = "transient" ;
    const std::string LITERAL_IF           = "if" ;
    const std::string LITERAL_PUBLIC       = "public" ;
    const std::string LITERAL_TRY          = "try" ;
    const std::string LITERAL_CONTINUE     = "continue" ;
    const std::string LITERAL_IMPLEMENTS   = "implements" ;
    const std::string LITERAL_RETURN       = "return" ;
    const std::string LITERAL_VOID         = "void" ;
    const std::string LITERAL_DEFAULT      = "default" ;
    const std::string LITERAL_IMPORT       = "import" ;
    const std::string LITERAL_SHORT        = "short" ;
    const std::string LITERAL_VOLATILE     = "volatile" ;
    const std::string LITERAL_DO           = "do" ;
    const std::string LITERAL_INSTANCEOF   = "instanceof" ;
    const std::string LITERAL_STATIC       = "static" ;
    const std::string LITERAL_WHILE        = "while" ;
    
    const std::string LITERAL_TRUE         = "true" ;
    const std::string LITERAL_FALSE        = "false" ;
    const std::string LITERAL_NULL         = "null" ;
    
} // Java Abstract Alphabet
